import { defineComponent as c, mergeModels as p, useModel as g, openBlock as n, createElementBlock as u, createElementVNode as a, normalizeClass as s, createTextVNode as k, toDisplayString as m, renderSlot as f, Fragment as v, withDirectives as w, vModelDynamic as B, createCommentVNode as h, vModelRadio as $, normalizeStyle as x, renderList as V, vModelSelect as M, ref as q, onMounted as z, withModifiers as S, withKeys as D } from "vue";
const L = { class: "flex items-center" }, I = ["value", "name", "checked", "disabled", "readonly", "required"], E = /* @__PURE__ */ c({
  __name: "BaseCheckbox",
  props: /* @__PURE__ */ p({
    label: { default: "" },
    labelClass: { default: "" },
    class: { default: "" },
    checked: { type: Boolean, default: !1 },
    name: { default: "bordered-checkbox" },
    disabled: { type: Boolean, default: !1 },
    readonly: { type: Boolean, default: !1 },
    required: { type: Boolean, default: !1 }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ p(["onClick", "onChange"], ["update:modelValue"]),
  setup(i, { emit: t }) {
    const e = g(i, "modelValue"), d = t, l = (r) => {
      d("onClick", r);
    }, o = (r) => {
      d("onChange", r);
    };
    return (r, C) => (n(), u("div", L, [
      a("input", {
        id: "bordered-checkbox-2",
        type: "checkbox",
        class: s(["w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 rounded focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600", r.class]),
        value: e.value,
        name: r.name,
        checked: r.checked,
        disabled: r.disabled,
        readonly: r.readonly,
        required: r.required,
        onClick: l,
        onChange: o
      }, null, 42, I),
      a("label", {
        for: "bordered-checkbox-2",
        class: s(["w-full py-4 ms-2 text-sm font-medium text-gray-900 dark:text-gray-300", r.labelClass])
      }, [
        k(m(r.label) + " ", 1),
        f(r.$slots, "inside")
      ], 2)
    ]));
  }
}), R = /* @__PURE__ */ c({
  __name: "BaseDropDown",
  props: {
    label: { default: "Default Select" },
    labelClass: { default: "" },
    class: { default: "" },
    dropdownClass: { default: "" }
  },
  setup(i) {
    return (t, e) => (n(), u(v, null, [
      a("button", {
        id: "dropdownCheckboxButton",
        "data-dropdown-toggle": "dropdownDefaultCheckbox",
        class: s(["text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:outline-none focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 text-center inline-flex items-center dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800", t.labelClass]),
        type: "button"
      }, [
        k(m(t.label) + " ", 1),
        f(t.$slots, "rightIcon")
      ], 2),
      a("div", {
        id: "dropdownDefaultCheckbox",
        class: s(["z-10 hidden w-48 bg-white divide-y divide-gray-100 rounded-lg shadow dark:bg-gray-700 dark:divide-gray-600", t.class])
      }, [
        a("span", {
          class: s(["p-3 space-y-3 text-sm text-gray-700 dark:text-gray-200", t.dropdownClass]),
          "aria-labelledby": "dropdownCheckboxButton"
        }, [
          f(t.$slots, "dropdownItems")
        ], 2)
      ], 2)
    ], 64));
  }
}), F = { class: "relative block w-full" }, N = ["type", "placeholder", "disabled", "required", "title", "size", "maxlength", "min", "pattern", "autofocus"], O = /* @__PURE__ */ c({
  __name: "BaseInput",
  props: /* @__PURE__ */ p({
    placeholder: { default: "" },
    label: { default: "" },
    disabled: { type: Boolean, default: !1 },
    required: { type: Boolean, default: !1 },
    class: { default: "" },
    labelClass: { default: "" },
    title: { default: "" },
    type: { default: "text" },
    size: { default: 20 },
    maxLength: { default: "32" },
    minLength: { default: "0" },
    regExpForInput: { default: "" },
    validationStatus: { type: Boolean, default: !1 },
    validationMessage: { default: "Somethings went wrong !" },
    validationMessageStyle: { default: "" },
    autoFocus: { type: Boolean, default: !1 }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(i) {
    const t = g(i, "modelValue");
    return (e, d) => (n(), u("div", null, [
      a("label", {
        class: s(["block mb-2 text-sm font-medium text-gray-900 dark:text-white", e.labelClass])
      }, m(e.label), 3),
      a("div", F, [
        f(e.$slots, "prefix"),
        w(a("input", {
          "onUpdate:modelValue": d[0] || (d[0] = (l) => t.value = l),
          id: "inputBox",
          class: s(["w-full text-gray-900 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500", e.class]),
          type: e.type,
          placeholder: e.placeholder,
          disabled: e.disabled,
          required: e.required,
          title: e.title,
          size: e.size,
          maxlength: e.maxLength,
          min: e.minLength,
          pattern: e.regExpForInput ? e.regExpForInput : "",
          autofocus: e.autoFocus
        }, null, 10, N), [
          [B, t.value]
        ]),
        f(e.$slots, "suffix")
      ]),
      e.validationStatus ? (n(), u("p", {
        key: 0,
        class: s(["mt-2 text-sm", e.validationMessageStyle])
      }, m(e.validationMessage), 3)) : h("", !0)
    ]));
  }
}), _ = { class: "flex items-center" }, K = ["value", "name"], T = /* @__PURE__ */ c({
  __name: "BaseRadio",
  props: /* @__PURE__ */ p({
    label: { default: "Radio Button" },
    labelClass: { default: "" },
    class: { default: "" },
    checked: { type: Boolean, default: !1 },
    name: { default: "default-radio" },
    disabled: { type: Boolean, default: !1 },
    value: { type: [String, Number, Boolean], default: "" }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(i) {
    const t = g(i, "modelValue");
    return (e, d) => (n(), u("div", _, [
      w(a("input", {
        id: "default-radio-2",
        type: "radio",
        "onUpdate:modelValue": d[0] || (d[0] = (l) => t.value = l),
        value: e.value,
        name: e.name,
        class: "w-4 h-4 text-blue-600 bg-gray-100 border-gray-300 focus:ring-blue-500 dark:focus:ring-blue-600 dark:ring-offset-gray-800 focus:ring-2 dark:bg-gray-700 dark:border-gray-600"
      }, null, 8, K), [
        [$, t.value]
      ]),
      a("label", {
        for: "default-radio-2",
        class: s(["ms-2 text-sm font-medium text-gray-900 dark:text-gray-300", e.labelClass])
      }, m(e.label), 3)
    ]));
  }
}), U = { class: "w-6/12 p-5" }, Z = ["name", "disabled", "required"], j = ["value"], A = /* @__PURE__ */ c({
  __name: "BaseSelectInput",
  props: /* @__PURE__ */ p({
    label: { default: "Default Select" },
    labelClass: { default: "" },
    class: { default: "" },
    optionClass: { default: "" },
    name: { default: "select-input" },
    disabled: { type: Boolean, default: !1 },
    required: { type: Boolean, default: !1 },
    optionLabel: {},
    options: { default: null },
    hideDefaultChooseOption: { type: Boolean, default: !1 }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(i) {
    const t = g(i, "modelValue");
    return (e, d) => (n(), u("div", U, [
      a("label", {
        for: "default-select-input",
        class: s(["block mb-2 text-sm font-medium text-gray-900 dark:text-white", e.labelClass])
      }, m(e.label), 3),
      w(a("select", {
        id: "default-select-input",
        class: s(["bg-gray-50 border border-gray-300 text-gray-900 mb-6 text-sm rounded-lg focus:ring-blue-500 focus:border-blue-500 block w-full p-2.5 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500", e.class]),
        name: e.name,
        disabled: e.disabled,
        required: e.required,
        "onUpdate:modelValue": d[0] || (d[0] = (l) => t.value = l)
      }, [
        a("option", {
          style: x(`display : ${e.hideDefaultChooseOption ? "none" : "block"}`),
          selected: "",
          value: "",
          class: s(e.optionClass)
        }, m(e.optionLabel), 7),
        (n(!0), u(v, null, V(e.options, (l) => (n(), u("option", {
          value: l.value,
          class: s(e.optionClass)
        }, m(l == null ? void 0 : l.name), 11, j))), 256))
      ], 10, Z), [
        [M, t.value]
      ])
    ]));
  }
}), P = ["value", "name", "disabled", "readonly", "required", "rows", "cols", "placeholder", "minlength", "maxlength"], W = /* @__PURE__ */ c({
  __name: "BaseTextArea",
  props: /* @__PURE__ */ p({
    label: { default: "" },
    labelClass: { default: "" },
    class: { default: "" },
    name: { default: "base-text-area" },
    disabled: { type: Boolean, default: !1 },
    readonly: { type: Boolean, default: !1 },
    required: { type: Boolean, default: !1 },
    rows: { default: "10" },
    cols: { default: "30" },
    placeholder: { default: "" },
    minlength: { default: "" },
    maxlength: { default: "" },
    autoResize: { type: Boolean, default: !1 }
  }, {
    modelValue: {},
    modelModifiers: {}
  }),
  emits: /* @__PURE__ */ p(["onChange"], ["update:modelValue"]),
  setup(i, { emit: t }) {
    const e = g(i, "modelValue"), d = (o) => {
      const r = o.target;
      e.value = r.value, l("onChange", o);
    }, l = t;
    return (o, r) => (n(), u(v, null, [
      a("label", {
        class: s(["block mb-2 text-sm font-medium text-gray-900 dark:text-white", o.labelClass])
      }, m(o.label), 3),
      a("textarea", {
        class: s(["block p-2.5 w-full text-sm text-gray-900 bg-gray-50 rounded-lg border border-gray-300 focus:ring-blue-500 focus:border-blue-500 dark:bg-gray-700 dark:border-gray-600 dark:placeholder-gray-400 dark:text-white dark:focus:ring-blue-500 dark:focus:border-blue-500", o.class]),
        style: x(`resize : ${o.autoResize ? "both" : "none"}`),
        value: e.value,
        name: o.name,
        disabled: o.disabled,
        readonly: o.readonly,
        required: o.required,
        rows: o.rows,
        cols: o.cols,
        placeholder: o.placeholder,
        minlength: o.minlength,
        maxlength: o.maxlength,
        onInput: d
      }, null, 46, P)
    ], 64));
  }
}), G = ["disabled"], H = /* @__PURE__ */ a("path", {
  d: "M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z",
  fill: "currentColor"
}, null, -1), J = /* @__PURE__ */ a("path", {
  d: "M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z",
  fill: "#1C64F2"
}, null, -1), Q = [
  H,
  J
], X = /* @__PURE__ */ c({
  __name: "BaseButton",
  props: {
    class: { default: "" },
    loadingClass: { default: "" },
    name: { default: "base-button" },
    disabled: { type: Boolean, default: !1 },
    loading: { type: Boolean, default: !1 }
  },
  emits: ["onClick"],
  setup(i, { emit: t }) {
    const e = t, d = () => {
      e("onClick");
    };
    return (l, o) => (n(), u("button", {
      type: "button",
      class: s(["text-white bg-blue-700 hover:bg-blue-800 focus:ring-4 focus:ring-blue-300 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-blue-600 dark:hover:bg-blue-700 focus:outline-none dark:focus:ring-blue-800", l.class]),
      disabled: l.disabled,
      onClick: d
    }, [
      f(l.$slots, "customPrefix"),
      f(l.$slots, "prefix"),
      k(" " + m(l.name) + " ", 1),
      f(l.$slots, "customSuffix"),
      l.loading ? (n(), u("svg", {
        key: 0,
        "aria-hidden": "true",
        role: "status",
        class: s(["inline w-4 h-4 ms-1 text-gray-200 animate-spin dark:text-gray-600", l.loadingClass]),
        viewBox: "0 0 100 101",
        fill: "none",
        xmlns: "http://www.w3.org/2000/svg"
      }, Q, 2)) : h("", !0)
    ], 10, G));
  }
}), Y = /* @__PURE__ */ a("div", { class: "bg-gray-900 bg-opacity-50 dark:bg-opacity-80 fixed inset-0 z-40" }, null, -1), ee = { class: "relative bg-white rounded-lg shadow dark:bg-gray-700" }, le = /* @__PURE__ */ a("svg", {
  class: "w-5 h-5",
  fill: "currentColor",
  viewBox: "0 0 20 20",
  xmlns: "http://www.w3.org/2000/svg"
}, [
  /* @__PURE__ */ a("path", {
    "clip-rule": "evenodd",
    d: "M4.293 4.293a1 1 0 011.414 0L10 8.586l4.293-4.293a1 1 0 111.414 1.414L11.414 10l4.293 4.293a1 1 0 01-1.414 1.414L10 11.414l-4.293 4.293a1 1 0 01-1.414-1.414L8.586 10 4.293 5.707a1 1 0 010-1.414z",
    "fill-rule": "evenodd"
  })
], -1), ae = {
  key: 0,
  class: "p-6 rounded-b border-gray-200 border-t dark:border-gray-600"
}, te = /* @__PURE__ */ c({
  __name: "BaseModal",
  props: {
    notEscapable: { type: Boolean, default: !1 },
    persistent: { type: Boolean, default: !1 },
    size: { default: "2xl" }
  },
  emits: ["close", "click:outside"],
  setup(i, { emit: t }) {
    const e = i, d = t, l = {
      xs: "max-w-xs",
      sm: "max-w-sm",
      md: "max-w-md",
      lg: "max-w-lg",
      xl: "max-w-xl",
      "2xl": "max-w-2xl",
      "3xl": "max-w-3xl",
      "4xl": "max-w-4xl",
      "5xl": "max-w-5xl",
      "6xl": "max-w-6xl",
      "7xl": "max-w-7xl"
    };
    function o() {
      d("close");
    }
    function r() {
      e.persistent || (d("click:outside"), o());
    }
    function C() {
      !e.notEscapable && !e.persistent && o();
    }
    const y = q(null);
    return z(() => {
      y.value && y.value.focus();
    }), (b, oe) => (n(), u("div", null, [
      Y,
      a("div", {
        ref_key: "modRef",
        ref: y,
        class: "overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-50 w-full md:inset-0 h-modal md:h-full justify-center items-center flex",
        tabindex: "0",
        onClick: S(r, ["self"]),
        onKeyup: D(C, ["esc"])
      }, [
        a("div", {
          class: s([`${l[b.size]}`, "relative p-4 w-full h-full"])
        }, [
          a("div", ee, [
            a("div", {
              class: s([
                b.$slots.header ? "border-b border-gray-200 dark:border-gray-600" : "",
                "p-4 rounded-t flex justify-between items-center"
              ])
            }, [
              f(b.$slots, "header"),
              b.persistent ? h("", !0) : (n(), u("button", {
                key: 0,
                "aria-label": "close",
                class: "text-gray-400 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm p-1.5 ml-auto inline-flex items-center dark:hover:bg-gray-600 dark:hover:text-white",
                type: "button",
                onClick: o
              }, [
                f(b.$slots, "close-icon", {}, () => [
                  le
                ])
              ]))
            ], 2),
            a("div", {
              class: s([b.$slots.header ? "" : "pt-0", "p-6"])
            }, [
              f(b.$slots, "body")
            ], 2),
            b.$slots.footer ? (n(), u("div", ae, [
              f(b.$slots, "footer")
            ])) : h("", !0)
          ])
        ], 2)
      ], 544)
    ]));
  }
}), de = {
  BaseInput: O,
  BaseCheckboxVue: E,
  BaseTextAreaVue: W,
  BaseSelectInputVue: A,
  BaseDropDownVue: R,
  BaseRadioVue: T,
  BaseButtonVue: X,
  BaseModalVue: te
};
export {
  de as default
};
